Subject: bug#35209: closed (Re: bug#35209: Bug in zdiff argument of an option separated by a space is not handled correctly)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 29 Mar 2022 23:55:02 +0000

Your bug report

#35209: Bug in zdiff argument of an option separated by a space is not handled correctly

which was filed against the gzip package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
35209: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=35209
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#35209: Bug in zdiff argument of an option separated by a space is not handled correctly
From: Paul Eggert <[email-masked]>
To: Bram Mertens <[email-masked]>
Cc: [email-masked]
Date: Tue, 29 Mar 2022 16:53:58 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

On 4/9/19 07:11, Bram Mertens wrote:

> The zdiff script does not handle options with arguments separated by a
> space correctly.

Thanks for reporting that. Lv Ying eventually followed up here:

https://bugs.gnu.org/54291

and as mentioned there, a patch has been installed and should be in the 
next gzip release.

Subject: Bug in zdiff argument of an option separated by a space is not handled correctly
From: Bram Mertens <[email-masked]>
To: [email-masked]
Date: Tue, 9 Apr 2019 16:11:14 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

The zdiff script does not handle options with arguments separated by a
space correctly.

The following if a valid diff command: "diff -y -W 200 /tmp/b1 /tmp/b2".
But when passed to zdiff the space between "-W" and 200 causes the
COLUMNS argument to be interpreted as a file:
zdiff -y -W 200 /tmp/b1 /tmp/b2
/bin/zdiff: 72: /bin/zdiff: cannot open 200: No such file

The error is caused by the following line in the loop that processes
the arguments:
-?*) cmp="$cmp '$1'";; (line 63 in version  1.6)

There should be an additional check to catch options with arguments. I
couldn't come up with a working solution quickly so I am currently
using a workaround.
If I remove the space between the option "-W" and it's COLUMNS
argument the script works as expected.

With this workaround the zdiff utility is great solution for the
problem I'm working on, thanks!

Thanks in advance

Bram Mertens